/* Source code derived from UNIX Network Programming Vol1, 
   Third Edition: The Sockets Networking API 
 */
#include <netinet/in.h>
#include <strings.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>

#include "helpers.c"

#define SERV_PORT 8080
#define MAX_BUF 4096

void file_cli(int sockfd);

int
main(int argc, char **argv)
{
     int     sockfd;
     struct sockaddr_in servaddr;

     sockfd = socket(AF_INET, SOCK_STREAM, 0);

     bzero(&servaddr, sizeof(servaddr));
     servaddr.sin_family = AF_INET;
     servaddr.sin_port = htons(SERV_PORT);
     inet_pton(AF_INET, "127.0.0.1", &servaddr.sin_addr);

     if (connect(sockfd, (struct sockaddr *) &servaddr, 
		 sizeof(servaddr)) < 0) {
	  printf("connect failed: %s\n", strerror(errno));
	  exit(-1);
     }
     
     file_cli(sockfd);     /* do it all */

     exit(0);
}


void
file_cli(int sockfd)
{
     char    buf[MAX_BUF];

     FILE *fd = fopen("cli.txt", "r");
     if (!fd) {
	  perror("cannot open file");
	  return;
     }
     int n = 0;
     while ((n = fread(buf, 1, MAX_BUF, fd))) {
	  printf("within while loop, read %d bytes\n", n);
	  int r = writen(sockfd, buf, n);
	  if (r < 0) {
	       printf("error writing %s\n", strerror(errno));
	       return;
	  }
     }
     if (!feof(fd))
	  perror("could not send file entirely\n");
     fclose(fd);
}
