/* Source code derived from UNIX Network Programming Vol1, 
   Third Edition: The Sockets Networking API 
 */

#include    <netinet/in.h>
#include <strings.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include "helpers.c"

#define MAX_BUFF 4096
#define SERV_PORT 8080

void file_read(int sockfd);

int
main(int argc, char **argv)
{
     int     listenfd, connfd;
     pid_t   childpid;
     socklen_t clilen;
     struct sockaddr_in cliaddr, servaddr;

     listenfd = socket(AF_INET, SOCK_STREAM, 0);

     bzero(&servaddr, sizeof(servaddr));
     servaddr.sin_family = AF_INET;
     //servaddr.sin_addr.s_addr = htonl (INADDR_ANY);
     inet_pton(AF_INET, "127.0.0.1", &servaddr.sin_addr);
     servaddr.sin_port = htons (SERV_PORT);

     bind(listenfd, (struct sockaddr *) &servaddr, sizeof(servaddr));

     listen(listenfd, 128);

     for ( ; ; )  {
	  clilen = sizeof(cliaddr);
	  connfd = accept(listenfd, (struct sockaddr *) &cliaddr, &clilen);

	  if ( (childpid = fork()) == 0) { /* child process */
	       close(listenfd);    /* close listening socket */
	       file_read(connfd);   /* process the request */
	       exit (0);
	  }
	  close(connfd);          /* parent closes connected socket */
     }
}

void
file_read(int sockfd)
{
     ssize_t n;
     char    buf[MAX_BUFF];

     FILE *fd = fopen("srv.txt", "w");
     if (!fd) {
	  perror("cannot open file");
	  return;
     }
     do {
	  int got = readn(sockfd, buf, MAX_BUFF);
	  printf("got %d bytes\n", got);
	  if (got < 0) {
	       printf("error reading from socket\n");
	       return;
	  }
	  
	  if (got == 0) // EOF
	       break;
	  
	  if (fwrite(buf, 1, got, fd) < got) {
	       perror("error writing to file");
	       return;
	  }

	  if (got < MAX_BUFF)
	       break;  // EOF
     } while(1);
     printf("done writing file\n");
     fclose(fd);
}
